package com.codename1.samples;


import static com.codename1.ui.CN.*;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Dialog;
import com.codename1.ui.Label;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import com.codename1.io.Log;
import com.codename1.ui.Toolbar;
import java.io.IOException;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.io.NetworkEvent;
import com.codename1.ui.Container;
import com.codename1.ui.FontImage;

/**
 * This file was generated by <a href="https://www.codenameone.com/">Codename One</a> for the purpose 
 * of building native mobile applications using Java.
 */
public class DnDRegression3048 {

    private Form current;
    private Resources theme;

    public void init(Object context) {
        // use two network threads instead of one
        updateNetworkThreadCount(2);

        theme = UIManager.initFirstTheme("/theme");

        // Enable Toolbar on all Forms by default
        Toolbar.setGlobalToolbar(true);

        // Pro only feature
        Log.bindCrashProtection(true);

        addNetworkErrorListener(err -> {
            // prevent the event from propagating
            err.consume();
            if(err.getError() != null) {
                Log.e(err.getError());
            }
            Log.sendLogAsync();
            Dialog.show("Connection Error", "There was a networking error in the connection to " + err.getConnectionRequest().getUrl(), "OK", null);
        });        
    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        Container cnt = new Container();
        Label imageLbl = new Label();
        FontImage.setIcon(imageLbl, FontImage.MATERIAL_10K, 10);
        cnt.add(imageLbl);
        cnt.add(new Label("Another label in the container"));
        imageLbl.setDraggable(true);
        boolean isTest = true;
        if (!isTest) {
            cnt.putClientProperty("isTest", false);            
        } else {
            cnt.putClientProperty("isTest", true);
        }
        cnt.setLeadComponent(imageLbl);
        cnt.setDraggable(true);
        imageLbl.addPointerDraggedListener((evt) -> {
            System.out.println("in drag");          
        });
	cnt.addDragFinishedListener((evt) -> {

           System.out.println("Drag finished");
        });
        
        Form hi = new Form("Hi World", BoxLayout.y());
        hi.add(cnt);
        hi.show();
    }

    public void stop() {
        current = getCurrentForm();
        if(current instanceof Dialog) {
            ((Dialog)current).dispose();
            current = getCurrentForm();
        }
    }
    
    public void destroy() {
    }

}
