package com.codename1.samples;


import com.codename1.components.SpanButton;
import static com.codename1.ui.CN.*;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Dialog;
import com.codename1.ui.Label;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import com.codename1.io.Log;
import com.codename1.ui.Toolbar;
import java.io.IOException;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.io.NetworkEvent;
import com.codename1.ui.Button;
import com.codename1.ui.Container;
import com.codename1.ui.layouts.BorderLayout;

/**
 * This file was generated by <a href="https://www.codenameone.com/">Codename One</a> for the purpose 
 * of building native mobile applications using Java.
 */
public class DraggableContainingSpanLabel {

    private Form current;
    private Resources theme;

    public void init(Object context) {
        // use two network threads instead of one
        updateNetworkThreadCount(2);

        theme = UIManager.initFirstTheme("/theme");

        // Enable Toolbar on all Forms by default
        Toolbar.setGlobalToolbar(true);

        // Pro only feature
        Log.bindCrashProtection(true);

        addNetworkErrorListener(err -> {
            // prevent the event from propagating
            err.consume();
            if(err.getError() != null) {
                Log.e(err.getError());
            }
            Log.sendLogAsync();
            Dialog.show("Connection Error", "There was a networking error in the connection to " + err.getConnectionRequest().getUrl(), "OK", null);
        });        
    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        Form hi = new Form("SpanButton ", BoxLayout.y());
{
    Button button1 = new Button("Normal Button, no lead");
    Container draggableContainer = BorderLayout.centerCenterEastWest(button1, new Button("Other"), null);
    draggableContainer.setDraggable(true);
    hi.add(draggableContainer);
    //observation: container not draggable 
}
{
    Button button2 = new Button("Normal Button, lead");
    Container draggableContainer = BorderLayout.centerCenterEastWest(button2, new Button("Other"), null);
    draggableContainer.setDraggable(true);
    draggableContainer.setLeadComponent(button2); //undocumented why a draggable Container doesn't work without a LeadComponent
    hi.add(draggableContainer);
    //observation: container draggable 
}
{
    SpanButton button3 = new SpanButton("SpanButton, lead");
    Button other = new Button("Other");
    Container draggableContainer = BorderLayout.centerCenterEastWest(button3, other, null);
    draggableContainer.setDraggable(true);
    draggableContainer.setLeadComponent(other);
    hi.add(draggableContainer);
    //observation: container not draggable (well, "Other" can initiate a drag, but container disappears
}
hi.show();
    }

    public void stop() {
        current = getCurrentForm();
        if(current instanceof Dialog) {
            ((Dialog)current).dispose();
            current = getCurrentForm();
        }
    }
    
    public void destroy() {
    }

}
