package com.codename1.samples;


import com.codename1.components.MediaPlayer;
import static com.codename1.ui.CN.*;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.Dialog;
import com.codename1.ui.Label;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import com.codename1.io.Log;
import com.codename1.ui.Toolbar;
import java.io.IOException;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.io.NetworkEvent;
import com.codename1.media.Media;
import com.codename1.media.MediaManager;
import com.codename1.ui.Button;
import com.codename1.ui.Container;
import com.codename1.ui.layouts.BorderLayout;

/**
 * This file was generated by <a href="https://www.codenameone.com/">Codename One</a> for the purpose 
 * of building native mobile applications using Java.
 */
public class SetLoopTest2969 {

    private Form current;
    private Resources theme;

    public void init(Object context) {
        // use two network threads instead of one
        updateNetworkThreadCount(2);

        theme = UIManager.initFirstTheme("/theme");

        // Enable Toolbar on all Forms by default
        Toolbar.setGlobalToolbar(true);

        // Pro only feature
        Log.bindCrashProtection(true);

        addNetworkErrorListener(err -> {
            // prevent the event from propagating
            err.consume();
            if(err.getError() != null) {
                Log.e(err.getError());
            }
            Log.sendLogAsync();
            Dialog.show("Connection Error", "There was a networking error in the connection to " + err.getConnectionRequest().getUrl(), "OK", null);
        });        
    }
    
    private Media media;
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        Form f = new Form("NativePlayerMode Test");
        f.setLayout(new BorderLayout());
        Container videoContainer = new Container(new BorderLayout());
        Button playButton = new Button("Play Video");
        playButton.addActionListener(e->{
            String videoPath;
            if (isSimulator()) {
                videoPath = "https://weblite.ca/cn1tests/small.mp4";
            } else {
                videoPath = "https://weblite.ca/cn1tests/small.mp4";
            }
            try {
                if (media != null) {
                    media.cleanup();
                    media = null;
                }
                Media video = MediaManager.createMedia(videoPath, true);
                MediaPlayer mp = new MediaPlayer(video);
                mp.setLoop(true);
                videoContainer.removeAll();
                videoContainer.add(CENTER, mp);
                media = media;
                f.revalidateWithAnimationSafety();
                
            } catch (Exception ex) {
                Log.e(ex);
            }
        });
        f.add(NORTH, playButton);
        f.add(CENTER, videoContainer);
        f.show();
    }

    public void stop() {
        current = getCurrentForm();
        if(current instanceof Dialog) {
            ((Dialog)current).dispose();
            current = getCurrentForm();
        }
    }
    
    public void destroy() {
    }

}
