package com.codename1.samples;


import static com.codename1.ui.CN.*;
import com.codename1.ui.Display;
import com.codename1.ui.Form;
import com.codename1.ui.BrowserComponent;
import com.codename1.ui.Button;
import com.codename1.ui.Dialog;
import com.codename1.ui.Label;
import com.codename1.ui.plaf.UIManager;
import com.codename1.ui.util.Resources;
import com.codename1.io.Log;
import com.codename1.ui.Toolbar;
import java.io.IOException;

import com.codename1.ui.layouts.BorderLayout;
import com.codename1.ui.layouts.BoxLayout;
import com.codename1.io.NetworkEvent;

/**
 * This file was generated by <a href="https://www.codenameone.com/">Codename One</a> for the purpose 
 * of building native mobile applications using Java.
 */
public class WKWebViewTest {

    private Form current;
    private Resources theme;
    private Form hi;
    
    
    public void init(Object context) {
        // use two network threads instead of one
        updateNetworkThreadCount(2);

        theme = UIManager.initFirstTheme("/theme");

        // Enable Toolbar on all Forms by default
        Toolbar.setGlobalToolbar(true);

        // Pro only feature, uncomment if you have a pro subscription
        Log.bindCrashProtection(true);

        addNetworkErrorListener(err -> {
            // prevent the event from propagating
            err.consume();
            if(err.getError() != null) {
                Log.e(err.getError());
            }
            Log.sendLogAsync();
            Dialog.show("Connection Error", "There was a networking error in the connection to " + err.getConnectionRequest().getUrl(), "OK", null);
        });        
    }
    
    public void start() {
        if(current != null){
            current.show();
            return;
        }
        hi = new Form("Hi World", BoxLayout.y());

        Button a = new Button("Show old webview");
        a.addActionListener((e) -> {
        	Display.getInstance().setProperty("BrowserComponent.useWKWebView", "false");
        	showWebView();
        });
        
        
        Button b = new Button("Show WKwebview");
        b.addActionListener((e) -> {
        	Display.getInstance().setProperty("BrowserComponent.useWKWebView", "true");
        	showWebView();
        });
        
        hi.add(a).add(b);
        
        hi.show();
    }
    
    private void showWebView() {
    	Form form = new Form();
    	BrowserComponent bc = new BrowserComponent();
    	form.setLayout(new BorderLayout());
    	form.add(BorderLayout.CENTER, bc);
    	bc.setURL("https://www.primefaces.org/primeng/#/");
    	
    	Button back = new Button("back");
    	back.addActionListener((e) -> {
    		hi.show();
    	});
    	form.add(BorderLayout.NORTH, back);
    	
    	form.show();
    }

    public void stop() {
        current = getCurrentForm();
        if(current instanceof Dialog) {
            ((Dialog)current).dispose();
            current = getCurrentForm();
        }
    }
    
    public void destroy() {
    }

}
